/*----------------------------------------------------------------------
 * Name: MMCMAIN.C
 * Purpose: SD/MMC Card Access Demo
 * Version: V1.03
 * Copyright (c) 2006 NXP Semiconductor. All rights reserved.
 *---------------------------------------------------------------------*/
#include <LPC214X.H> /* LPC214x definitions */
#include "type.h"
#include "spi_mmc.h"
#include "mmcmain.h"
extern BYTE MMCWRData[MMC_DATA_SIZE];
extern BYTE MMCRDData[MMC_DATA_SIZE];
/* Main Program */
void trans(char ch)
{
	U0THR=ch;
	while(!(U0LSR & 0x40));
}
int main (void)
{
DWORD i, BlockNum = 0;int j=0;
char mess[9] = {'p','r','o','g',' ','s','t','r','t'};
 PINSEL1 = 0x40004000;
 PINSEL0 |= 0x00000005;
	U0LCR = 0x83;
	U0DLL = 97;
	U0LCR = 0x03;
 IODIR1 = LED_MSK; /* LED's defined as Outputs */
 for(j=0;j<9;j++)
 trans(mess[j]);
 SPI_Init(); /* initialize SPI for MMC card */
 IOSET1 = LED_CFG;
 if ( mmc_init() != 0 )
 {
IOSET0 = SPI_SEL; /* set SSEL to high */
while ( 1 ); /* Very bad happened */
 }
 /* write, read back, and compare the complete 64KB on the MMC
 * card each block is 512 bytes, the total is 512 * 128 */
 for ( BlockNum = 0; BlockNum < MAX_BLOCK_NUM; BlockNum++ )
 {
IOCLR1 = LED_MSK;
IOSET1 = LED_WR;
if ( mmc_write_block(BlockNum) == 0 )
 {
 IOCLR1 = LED_MSK;
 IOSET1 = LED_RD;
 mmc_read_block(BlockNum);
 }
 else
 {
 IOSET0 = SPI_SEL; /* set SSEL to high */
 while ( 1 ); /* Very bad happened */
 }

for ( i = 0; i < MMC_DATA_SIZE; i++ ) /* Validate */
 {
if ( MMCRDData[i] != MMCWRData[i] )
{
IOSET0 = SPI_SEL; /* set SSEL to high */ 
while ( 1 ); /* Very bad happened */
 }
 }

for ( i = 0; i < MMC_DATA_SIZE; i++ ) /* clear read buffer */
 MMCRDData[i] = 0x00;
 }
 IOCLR1 = LED_MSK;
 IOSET1 = LED_DONE;
 while (1); /* Loop forever */
} 